/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "testscene.h"

void testSceneInit(testscene_t *scene, game_t *game) {
  assetFontLoad(&scene->font, "fonts/opensans/OpenSans-Bold.ttf");
  assetShaderLoad(&scene->shader,
    "shaders/textured.vert", "shaders/textured.frag"
  );
  

  vnTextBoxInit(&scene->box, &scene->font);
  scene->box.text = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent aliquam volutpat libero, vitae laoreet neque egestas et. Orci varius natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Fusce dui leo, molestie et consectetur quis, blandit eu velit. Suspendisse at dolor sed ligula consectetur luctus. Donec mollis semper lacus id pretium. Maecenas et magna lorem. Nullam non viverra dui. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Pellentesque dapibus facilisis ipsum, eu placerat justo pretium tempus. Quisque vehicula sapien vel sem ullamcorper vestibulum. Mauris pellentesque sapien vel volutpat imperdiet.";
  scene->box.widthMax = game->engine.render.width;
  vnTextBoxRebuffer(&scene->box);
}

void testSceneRender(testscene_t *scene, game_t *game) {
  if(false) {
    cameraLookAt(&scene->camera,
      300, 300, 300,
      0, 0, 0
    );
    cameraPerspective(&scene->camera, 75,
      game->engine.render.width/game->engine.render.height, 0.01, 1000.0
    );
  } else {
    cameraLookAt(&scene->camera,
      0, 0, 10,
      0, 0, 0
    );

    cameraOrtho(&scene->camera,
      0, game->engine.render.width,
      game->engine.render.height, 0,
      0.01, 1000.0
    );
  }

  shaderUse(&scene->shader);
  shaderUseCamera(&scene->shader, &scene->camera);

  vnTextBoxUpdate(&scene->box, &game->engine);
  vnTextBoxRender(&scene->box, &scene->shader);
}