/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>
#include "../util/array.h"
#include "../display/animation/timeline.h"

/**
 * Initialize the conversation set.
 * @param convo Conversation to initialize.
 */
void conversationInit(conversation_t *convo);

/**
 * Proceed to the next conversation element.
 * @param convo Conversation to advance.
 */
void conversationNext(conversation_t *convo);

/**
 * Add a text element to the conversation.
 * 
 * @param convo Conversation to add to.
 * @param speaker Speaker that said this thing.
 * @param text Text to speak
 * @return The pointer to the text element.
 */
conversationtext_t * conversationAdd(conversation_t *convo, uint8_t speaker,
  char *text
);